

/****** Object : Table [dbo].[Snmp] Copyright TECK SYSTEM SOFT 2024 one ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Insert_Date] = '' WHERE [Insert_Date] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Subject] = '' WHERE [Subject] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Application] = '' WHERE [Application] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [OID] = '' WHERE [OID] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Value] = '' WHERE [Value] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] SET [Availability] = '' WHERE [Availability] IS NULL

 INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilitySnmp]
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Subject]
	  ,[Application]
	  ,[OID]
      ,[Value] 
      ,[Mode] 
      ,[Alarm]
	  ,[Availability]
)

SELECT  
[Insert_Date]
       ,[Customer]
       ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[Subject]
	  ,[Application]
	  ,[OID]
      ,[Value] 
      ,[Mode] 
      ,[Alarm]
	  ,CONVERT(nvarchar(25),[Availability])
	  
FROM
/* CONVERT(nvarchar(25),[Insert_Date]) + '-' + */
(SELECT DISTINCT CONVERT(nvarchar(25),[Insert_Date]) + '-' +  [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Subject] +  '-' + [Application] + '-' + [OID] + '-' + [Value] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	  ,[Insert_Date] 
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Subject]
	  ,[Application]
	  ,[OID]
      ,[Value] 
      ,[Mode]
      ,[Alarm]
      ,[Availability] 

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp]
WHERE [Availability] = '1' AND CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Subject] +  '-' + [Application] + '-' + [OID] + '-' + [Value] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability]) NOT IN 

(SELECT DISTINCT  CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Subject] +  '-' + [Application] + '-' + [OID] + '-' + [Value] + '-' + [Alarm]  + '-' + CONVERT(nvarchar(10),[Availability]) AS SEARCH_STRING
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilitySnmp]) ) TBL 
/* WHERE [Availability] = 1 */

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilitySnmp] 
SET  [Value] = REQUEST.[Value],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability]
     /*[Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time */

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilitySnmp] SNMP,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Snmp_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Subject],
TEMP_JOIN.[Application],
TEMP_JOIN.[OID],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Value],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[Snmp] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE 
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Subject] =  TEMP_JOIN .[Subject] AND
TEMP.[Application] =  TEMP_JOIN .[Application] AND
TEMP.[OID] =  TEMP_JOIN .[OID] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Value] = TEMP_JOIN .[Value]AND
TEMP.[Alarm] = TEMP_JOIN .[Alarm] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]
GROUP BY
TEMP_JOIN.[Snmp_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Subject],
TEMP_JOIN.[Application],
TEMP_JOIN.[OID],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Value],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Snmp_ID) = TEMP_JOIN.[Snmp_ID]) AS REQUEST

WHERE
SNMP.[Customer] = REQUEST.[Customer]
AND SNMP.[Site] = REQUEST.[Site]
AND SNMP.[Domain] = REQUEST.[Domain]
AND SNMP.[Computer] = REQUEST.[Computer]
AND SNMP.[Alarm] = REQUEST.[Alarm]
AND SNMP.[Value] = REQUEST.[Value]
AND SNMP.[Availability] = REQUEST.[Availability]
   
TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[SnmpTemp]